public class Autonoleggio {


// Attributi
 private static final int MAX_NUM_VEICOLI=1000;
 private int posizione=-1;
 private Veicolo mezzi[];
 public Autonoleggio() {
  mezzi=new Veicolo[MAX_NUM_VEICOLI];
 }

// Metodi
 public int setVeicolo(Veicolo veicolo) {
  try { posizione++;
// inserimento copia di Veicolo in posizione relativa al posizione
   mezzi[posizione]=veicolo;
   return posizione; // restituisce la posizione di inserimento
  }
  catch (ArrayIndexOutOfBoundsException exception) {
   return -1; // posizione non valida
  }
 }
 public Veicolo getVeicolo(int posizione) {
  try {
  // restituisce una copia del Veicolo in posizione
   return mezzi[posizione];
  }
 catch (ArrayIndexOutOfBoundsException exception) {
  return null; // posizione non valida: nessun Veicolo restituito
 }
  catch (NullPointerException exception) {
   return null; // posizione vuota: nessun Veicolo restituito
  }
 }
 
 public Veicolo getVeicolo(String targa) {
  int i;   
  for (i=0;i<MAX_NUM_VEICOLI;i++)
     if (mezzi[i]!=null)
         if(mezzi[i].getTarga().equals(targa)) // restituisce una copia del Veicolo trovato
            return mezzi[i];
               
 return null; //veicolo non trovato
}
  
public int rimuoviVeicolo(int posizione) {
 try {
  mezzi[posizione]=null; // rimozione Veicolo in posizione
  return posizione; // restituisce la posizione liberata
 }
 catch (ArrayIndexOutOfBoundsException exception) {
  return -1; // posizione non valida
 }
}

public int rimuoviVeicolo(String targa) {
 int i;   
 for (i=0;i<MAX_NUM_VEICOLI;i++)
     if (mezzi[i]!=null)
         if(mezzi[i].getTarga().equals(targa)){
             mezzi[i]=null; // rimozione Veicolo in posizione
             return i; // restituisce la posizione liberata
           }
 return -1; // veicolo non trovato
}

public int getNumMaxmezzi() {
 return MAX_NUM_VEICOLI;
}
public int getNumMezzi() {
 int posizione, n=0;
 for (posizione=0; posizione<MAX_NUM_VEICOLI; posizione++)
  if (mezzi[posizione]!=null)
   n++;
  return n;
 }
}
