public class Carrello {
 private final int MAX_OGGETTI = 100;
 private int oggetti;
 private Merce[] contenutoCarrello;
 
 public Carrello() {
  contenutoCarrello = new Merce[MAX_OGGETTI];
  oggetti=0;
 }
 public void inserisciProdotto(Merce prodotto) {
  if (oggetti < MAX_OGGETTI) {
   contenutoCarrello[oggetti] = prodotto.clone();
   oggetti++;
  }
 }
 public double calcolaPrezzoTotale() {
  double prezzoTotale=0;
  for (int i=0; i<oggetti; i++)
   prezzoTotale += contenutoCarrello[i].calcolaImporto();
  return prezzoTotale;
 }
 public double calcolaCalorieTotali() {
  double calorieTotali=0;
  for (int i=0; i<oggetti; i++)
   if (contenutoCarrello[i] instanceof Alimentari)
    calorieTotali +=((Alimentari)contenutoCarrello[i]).calcolaCalorie();
  return calorieTotali;
 }
 public Merce[] esportaContenuto() {
   Merce prodotti[] = new Merce[oggetti];
   for (int i=0; i<oggetti; i++)
    prodotti[i] = contenutoCarrello[i].clone();
   return prodotti;
 }

public static void main(String[] args) {
 Carrello carrello = new Carrello();
 Abbigliamento abbigliamento1 = new Abbigliamento( "PU01", 50.00, 'M',"XL", "Pantaloni");
 Abbigliamento abbigliamento2 = new Abbigliamento( "CD22", 35.00,'F',"XS", "Camicia");
 Abbigliamento abbigliamento3 = new Abbigliamento( "GD46", 29.00, 'F',"S", "Giacca");
 Freschi freschi1 = new Freschi( "OR044", 1.50, "Peperoni", 1.4, 170, true);
 Freschi freschi2 = new Freschi( "FR012", 1.90, "Mele", 0.5, 730, false);
 Conservati conservati = new Conservati( "BS003", 2.00, "Biscotti",0.37, 1200, "Buoni e belli");
 carrello.inserisciProdotto(abbigliamento1);
 carrello.inserisciProdotto(abbigliamento2);
 carrello.inserisciProdotto(abbigliamento3);
 carrello.inserisciProdotto(freschi1);
 carrello.inserisciProdotto(freschi2);
 carrello.inserisciProdotto(conservati);
 Merce prodotti[] = carrello.esportaContenuto();
 for (int i=0; i<prodotti.length; i++)
  System.out.println(prodotti[i]);
  System.out.println( "Spesa totale: "+ carrello.calcolaPrezzoTotale());
  System.out.println( "Calorie totali: " + carrello.calcolaCalorieTotali());
 }
}